minor cosmetical cleanups...
[util-vserver.git] / util-vserver / scripts / chcontext
index 69f644c..76e030b 100755 (executable)
@@ -18,7 +18,7 @@
 
 : ${UTIL_VSERVER_VARS:=/usr/lib/util-vserver/util-vserver-vars}
 test -e "$UTIL_VSERVER_VARS" || {
-    echo "Can not find util-vserver installation; aborting..."
+    echo "Can not find util-vserver installation; aborting..." >&2
     exit 1
 }
 . "$UTIL_VSERVER_VARS"
@@ -93,10 +93,64 @@ function showVersion()
 $"chcontext $PACKAGE_VERSION -- allocates/enters a security context
 This program is part of $PACKAGE_STRING
 
-Copyright (C) 2003 Enrico Scholz
+Copyright (C) 2004 Enrico Scholz
 This program is free software; you may redistribute it under the terms of
 the GNU General Public License.  This program has absolutely no warranty."
     exit $1
 }
 
-isKernelAPI 0x00010012 || exec $_CHCONTEXT_COMPAT "$@"
+$_VSERVER_INFO - FEATURE migrate || exec $_CHCONTEXT_COMPAT "$@"
+
+tmp=$(getopt -o + --long cap:,ctx:,disconnect,domainname:,flag:,hostname:,secure,silent,help,version -n "$0" -- "$@") || exit 1
+eval set -- "$tmp"
+
+OPT_CAPS=()
+OPT_CTX=
+OPT_DISCONNECT=
+OPT_FLAGS=()
+OPT_SECURE=
+OPT_SILENT=
+
+while true; do
+    case "$1" in
+       --help)         showHelp $0 ;;
+       --version)      showVersion ;;
+       --cap)          OPT_CAPS=( "${OPT_CAPS[@]}" "$2" ); shift;;
+       --ctx)          OPT_CTX=$2; shift;;
+       --disconnect)   OPT_DISCONNECT=1;;
+       --domainname)   OPT_DOMAINNAME=$2; shift;;
+       --hostname)     OPT_HOSTNAME=$2;   shift;;
+       --flag)         OPT_FLAGS=( "${OPT_FLAGS[@]}" "$2" ); shift;;
+       --secure)       OPT_SECURE=1;;
+       --silent)       OPT_SILENT=1;;
+       --)             shift; break;;
+       *)              echo $"chcontext: internal error; arg=='$1'" >&2; exit 1;;
+    esac
+    shift
+done
+
+create_cmd=( $_VCONTEXT --create
+            ${OPT_SILENT:+--silent}
+            ${OPT_CTX:+--xid "$OPT_CTX"}
+            -- )
+
+chain_cmd=(  $_VATTRIBUTE -s
+            ${OPT_CAPS:+--cap "${OPT_CAPS[@]}"}
+            ${OPT_FLAGS:+--flag "${OPT_FLAGS[@]}"}
+            ${OPT_SECURE:+--secure}
+            --
+             $_VUNAME -s
+            ${OPT_DOMAINNAME:+--domainname "$OPT_DOMAINNAME"}
+            ${OPT_HOSTNAME:+--nodename "$OPT_HOSTNAME"}
+            -- )
+
+migrate_cmd=( $_VCONTEXT --migrate-self
+             ${OPT_SILENT:+--silent}
+             ${OPT_DISCONNECT:+--disconnect}
+             -- "$@" )
+
+"${create_cmd[@]}" "${chain_cmd[@]}" "${migrate_cmd[@]}"
+rc=$?
+
+test "$rc" -ne 254 || exec "${migrate_cmd[@]}"
+exit $rc